//*****************************************************************************
//
//      Class:          IconImage
//      Namespace:      Kerr.IconBrowser
//      Date created:   15 June 2001
//      Copyright:       Kenny Kerr 2002    http://www.kennyandkarin.com
//
//*****************************************************************************

#pragma once

#include "WindowsAPI.h"

namespace Kerr { namespace IconBrowser
{
    // Forward declaration
    __gc class Library;

    //
    // The IconImage class represents a single image in an IconResource.
    //
    __gc class IconImage
    {
    public:

    // Construction/destruction

        IconImage(Library* library,
                  System::IntPtr pResourceName);

    // Properties

        __property int get_Size();

    // Methods

        void WriteDirectoryEntry(System::IO::BinaryWriter* writer,
                                 WindowsAPI::UINT uiImageOffset);

        void WriteImage(System::IO::BinaryWriter* writer);

    private:

    // Data members

        System::Byte m_arDibBits[];

        int m_iHeight;
        int m_iWidth;
        int m_iColors;

    };

}}
