//*****************************************************************************
//
//      Class:          IconResource
//      Namespace:      Kerr.IconBrowser
//      Date created:   15 June 2001
//      Copyright:       Kenny Kerr 2002    http://www.kennyandkarin.com
//
//*****************************************************************************

#pragma once

#include "WindowsAPI.h"

namespace Kerr { namespace IconBrowser
{
    // Forward declarations
    __gc class Library;
    __gc class IconImage;

    //
    // The IconResource class represents an icon resource. Normally when you 
    // load an icon the operating system returns an icon image targeted to 
    // the current display. The IconResource class contains all the images in
    // the icon resource.
    //
    __gc class IconResource
    {
    public:

    // Construction/destruction

        IconResource(Library* library,
                     System::IntPtr pResourceName);

    // Properties

        __property System::String* get_Text();

    // Methods

        void Save(System::String* strFileName);

    private:

    // Helper functions

        void WriteHeader(System::IO::BinaryWriter* writer);
        void WriteDirectoryEntries(System::IO::BinaryWriter* writer);
        void WriteImages(System::IO::BinaryWriter* writer);
        int GetIcoImageOffset(int index);

    // Data members

        System::IntPtr m_pName;
        IconImage* m_images[];
        System::String* m_strText;
    };

}}
