//*****************************************************************************
//
//      Class:          Library
//      Namespace:      Kerr.IconBrowser
//      Date created:   15 June 2001
//      Copyright:       Kenny Kerr 2002    http://www.kennyandkarin.com
//
//*****************************************************************************

#pragma once

#include "WindowsAPI.h"

namespace Kerr { namespace IconBrowser
{
    //
    // The Library class allows you to load unmanaged libraries, such as 
    // executables and dynamic-link libraries.
    //
    __gc class Library : public System::IDisposable
    {
    public:

    // Construction/destruction

        Library(System::String* strFileName,
                WindowsAPI::DWORD dwFlags);

        Library(System::IntPtr hModule,
                bool bTakeOwnership);

        void Dispose();

    // Properties

        __property System::IntPtr get_Handle();

    // Methods

        void EnumResourceNames(System::IntPtr pType,
                               WindowsAPI::EnumResNameProc* enumFunc,
                               System::IntPtr param);
        
        System::IntPtr FindResource(System::IntPtr pName,
                                    System::IntPtr pType);

        System::IntPtr LoadResource(System::IntPtr hResource);
        WindowsAPI::DWORD SizeofResource(System::IntPtr hResource);
        System::Drawing::Icon* LoadIcon(System::IntPtr pName);

    private:

    // Data members

        System::IntPtr m_hModule;
        bool m_bOwn;
    };
}}
