//*****************************************************************************
//
//      Class:          MainWindow
//      Namespace:      Kerr.IconBrowser
//      Date created:   15 June 2001
//      Copyright:       Kenny Kerr 2002    http://www.kennyandkarin.com
//
//*****************************************************************************

#pragma once

namespace Kerr { namespace IconBrowser
{
    //
	// The MainWindow class provides the user-interface for the Icon Browser 
	// application.
    //
    __gc class MainWindow : public System::Windows::Forms::Form
    {
    public:

    // Construction/destruction

        MainWindow();

    private:

    // Event handlers

        void BrowseEventHandler(System::Object*, System::EventArgs*);
        void FileNameChangedEventHandler(System::Object*, System::EventArgs*);
        void GoEventHandler(System::Object*, System::EventArgs*);
        void ExportEventHandler(System::Object*, System::EventArgs*);
        void SelectionChangedEventHandler(System::Object*, System::EventArgs*);
        void ContextMenuPopupEventHandler(System::Object*, System::EventArgs*);

    // Helper functions

        void LoadWindowIcon();
        void CreateControlPanel();
        void CreateBrowserView();
        void UpdateExportButton();

        bool AddIconToList(System::IntPtr hModule,
                           System::IntPtr pType,
                           System::IntPtr pName,
                           System::IntPtr param);

    // Data members

        System::Windows::Forms::TextBox* m_edtFileName;
        System::Windows::Forms::Button* m_btnGo;
        System::Windows::Forms::Button* m_btnExport;
        System::Windows::Forms::ListView* m_lvBrowser;
        System::Windows::Forms::ImageList* m_ilIcons;
        System::Windows::Forms::MenuItem* m_miExport;
    };
}}
