// This is the main DLL file.

#include "stdafx.h"

#include "WindowSnapper.h"

using namespace NickHod::Drawing;

WindowSnapper::WindowSnapper()
:	m_IncludeMousePointer(false)
{
	m_pBitmap = new Bitmap(1,1);
}

WindowSnapper::~WindowSnapper()
{
}

void WindowSnapper::SnapDesktopWindow()
{
	SnapWindow(::GetDesktopWindow());
}

void WindowSnapper::SnapForegroundWindow()
{

	SnapWindow(::GetForegroundWindow());
}

void WindowSnapper::SnapWindow(NativeWindow* Window)
{
	WindowSnapper::SnapWindow(Window->Handle);
}

void WindowSnapper::SnapWindow(IntPtr ptrHwnd)
{
	HWND	hwnd = reinterpret_cast<HWND>(ptrHwnd.ToInt32());
	if (NULL == hwnd)
		throw new System::Exception(S"Invalid Argument");

	HDC	hdcTarget = ::CreateCompatibleDC(NULL);

	RECT	rcl; ::GetWindowRect(hwnd, &rcl);

	SIZE  size = { rcl.right-rcl.left, rcl.bottom-rcl.top };

	HDC	hdcWindow = ::GetWindowDC(hwnd);

	HBITMAP hBitmapTarget = ::CreateCompatibleBitmap(hdcWindow, size.cx, size.cy);

	HBITMAP hBitmapOld = (HBITMAP)::SelectObject(hdcTarget, hBitmapTarget);

	::BitBlt(hdcTarget, 0, 0, size.cx, size.cy, hdcWindow, 0, 0, SRCCOPY);

	if (m_IncludeMousePointer)
	{
		CURSORINFO ci; ::ZeroMemory(&ci, sizeof(ci));
		ci.cbSize = sizeof(ci);
		::GetCursorInfo(&ci);
		ICONINFO ii; ::ZeroMemory(&ii, sizeof(ii));
		::GetIconInfo(ci.hCursor, &ii);
		::DrawIcon(hdcTarget, ci.ptScreenPos.x-rcl.left-ii.xHotspot, ci.ptScreenPos.y-rcl.top-ii.yHotspot, ci.hCursor);
	}

	::ReleaseDC(hwnd, hdcWindow);

	m_pBitmap = Bitmap::FromHbitmap(hBitmapTarget);

	::DeleteObject(::SelectObject(hdcTarget, hBitmapOld));

	::DeleteDC(hdcTarget);

	// source the snapped event
	if (Snapped)
		Snapped->Invoke(this, new EventArgs());
}

void WindowSnapper::SnapWindow(Control* ControlOrForm)
{
	SnapWindow(ControlOrForm->Handle);
}

Bitmap* WindowSnapper::get_CurrentSnapshot(void)
{
	return m_pBitmap;
}

bool WindowSnapper::get_IncludeMousePointer(void)
{
	return m_IncludeMousePointer;
}

void WindowSnapper::set_IncludeMousePointer(bool IncludeMousePointer)
{
	m_IncludeMousePointer = IncludeMousePointer;
}
